'''
Copyright (C) 2017 JOSECONSCO
Created by JOSECONSCO

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

#DONE: Lilrary of garments
#DONE: Lilrary should hold target cloth data?
#DONE: Fix sewings with symmetry on instances
#DONE: ability to pull verts? By hooks? Dependency loop?
#DONE: sewing to 'frozen' curves. For stitching cloth to surface of another mesh.
#DONE: preview segments len when modeling
#DONE: sewing one segment to - multiple segments.
#TODO: max sewing force in GTool ui - expose - user requres


bl_info = {
    "name": "Garment Tool",
    "description": "Garment making tool for Blender",
    "author": "Bartosz Styperek",
    "version": (2, 0, 3),
    "blender": (3, 6, 0),
    "location": "Right 3d View Panel -> Garment ",
    "warning": "",
    "doc_url": "https://joseconseco.github.io/GarmentToolDocs/",
    "tracker_url": "https://discord.gg/cxZDbqH",
    "category": "Object",
}


if "bpy" in locals():
    import importlib
    importlib.reload(add_pattern_primitives)
    importlib.reload(helper_functions)
    importlib.reload(curve_helpers)
    importlib.reload(fsm_oper)
    importlib.reload(bind_mesh)
    importlib.reload(cloth_properties)
    importlib.reload(interaction_helpers)
    importlib.reload(cloth_pulling)
    importlib.reload(triangulate_curve_pattern)
    importlib.reload(cloth_ui)
    importlib.reload(mesh_cloth_functions)
    importlib.reload(edit_sewing)
    importlib.reload(edit_pockets)
    importlib.reload(edit_pins)
    importlib.reload(update_addon)
    importlib.reload(spline_base)
    importlib.reload(spline_modeling_tools)
    importlib.reload(pattern_cutting)
    importlib.reload(sewings_overlay)
    importlib.reload(garments_lib)
    importlib.reload(modal_save_garment)
    importlib.reload(cloth_presets_lib)
    importlib.reload(edit_bend)
    importlib.reload(edit_cloth_preset)
    importlib.reload(pattern_flat_uv)
else:
    from . import add_pattern_primitives
    from .utils import helper_functions
    from .utils import curve_helpers
    from .utils import fsm_oper
    from . import bind_mesh
    from . import cloth_properties
    from .cloth_interaction import interaction_helpers
    from .cloth_interaction import cloth_pulling
    from . import triangulate_curve_pattern
    from . import cloth_ui
    from . import mesh_cloth_functions
    from . import edit_sewing
    from . import edit_pockets
    from . import edit_pins
    from . import update_addon
    from .spline_tools import spline_base
    from .spline_tools import spline_modeling_tools
    from .spline_tools import pattern_cutting
    from .spline_tools import sewings_overlay
    from .garments_library import garments_lib
    from .garments_library import modal_save_garment
    from . import cloth_presets_lib
    from . import edit_bend
    from . import edit_cloth_preset
    from . import pattern_flat_uv


import bpy
from . import auto_load

auto_load.init()

def menu_func(self, context):
    self.layout.operator_menu_enum("curve.add_sewing_pattern", "pattern_type",icon='MOD_CLOTH')

def register():
    auto_load.register()
    cloth_properties.register_props()
    garments_lib.reg()
    # cloth_presets_lib.init_cloth_presets()
    sewings_overlay.register()
    bpy.types.VIEW3D_MT_add.append(menu_func)


def unregister():
    bpy.types.VIEW3D_MT_add.remove(menu_func)
    sewings_overlay.unreg()
    garments_lib.unreg()
    cloth_properties.unregister_props()
    auto_load.unregister()



